// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.order;

import fr.ifremer.adagio.core.dao.referential.ObjectType;
import fr.ifremer.adagio.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Type de tri, par exemple :
 * - tri des lieux par ordre géographique du Nord au sud
 * - ...
 */
// HibernateEntity.vsl annotations merge-point
public abstract class OrderType
    implements Serializable, Comparable<OrderType>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 564409648916955743L;

    // Generate 4 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String name;

    /**
     * 
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * 
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private String description;

    /**
     * 
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * 
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 3 associations
    private Collection<OrderItem> orderItems = new HashSet<OrderItem>();

    /**
     * Entité de tri.
     * Réprésente une entité (Location, gear, etc.) triée au sein d'un type de tri.
     * @return this.orderItems Collection<OrderItem>
     */
    public Collection<OrderItem> getOrderItems()
    {
        return this.orderItems;
    }

    /**
     * Entité de tri.
     * Réprésente une entité (Location, gear, etc.) triée au sein d'un type de tri.
     * @param orderItemsIn Collection<OrderItem>
     */
    public void setOrderItems(Collection<OrderItem> orderItemsIn)
    {
        this.orderItems = orderItemsIn;
    }

    /**
     * Entité de tri.
     * Réprésente une entité (Location, gear, etc.) triée au sein d'un type de tri.
     * @param elementToAdd OrderItem
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addOrderItems(OrderItem elementToAdd)
    {
        return this.orderItems.add(elementToAdd);
    }

    /**
     * Entité de tri.
     * Réprésente une entité (Location, gear, etc.) triée au sein d'un type de tri.
     * @param elementToRemove OrderItem
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeOrderItems(OrderItem elementToRemove)
    {
        return this.orderItems.remove(elementToRemove);
    }

    private Status status;

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private ObjectType objectType;

    /**
     * Type d'entités concernés par le type de tri.
     * @return this.objectType ObjectType
     */
    public ObjectType getObjectType()
    {
        return this.objectType;
    }

    /**
     * Type d'entités concernés par le type de tri.
     * @param objectTypeIn ObjectType
     */
    public void setObjectType(ObjectType objectTypeIn)
    {
        this.objectType = objectTypeIn;
    }

    /**
     * Returns <code>true</code> if the argument is an OrderType instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof OrderType))
        {
            return false;
        }
        final OrderType that = (OrderType)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link OrderType}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link OrderType}.
         * @return new OrderTypeImpl()
         */
        public static OrderType newInstance()
        {
            return new OrderTypeImpl();
        }

        /**
         * Constructs a new instance of {@link OrderType}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param name String
         * @param status Status
         * @param objectType ObjectType
         * @return newInstance
         */
        public static OrderType newInstance(String name, Status status, ObjectType objectType)
        {
            final OrderType entity = new OrderTypeImpl();
            entity.setName(name);
            entity.setStatus(status);
            entity.setObjectType(objectType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link OrderType}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param name String
         * @param description String
         * @param updateDate Timestamp
         * @param orderItems Collection<OrderItem>
         * @param status Status
         * @param objectType ObjectType
         * @return newInstance OrderType
         */
        public static OrderType newInstance(String name, String description, Timestamp updateDate, Collection<OrderItem> orderItems, Status status, ObjectType objectType)
        {
            final OrderType entity = new OrderTypeImpl();
            entity.setName(name);
            entity.setDescription(description);
            entity.setUpdateDate(updateDate);
            entity.setOrderItems(orderItems);
            entity.setStatus(status);
            entity.setObjectType(objectType);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(OrderType o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// OrderType.java merge-point
}